/*
 * DiscStatus.java
 *
 * Copyright (c) 2007  Vreixo Formoso
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See COPYING file for details.
 */

package org.pykix.libburnia.libburn;

/**
 * Possible status' of the drive in regard to the disc in it.
 * 
 * @author Vreixo Formoso
 * @since 0.1
 */
public enum DiscStatus {

	/** The current status is not yet known. */
	UNREADY,
	
	/** The drive holds a blank disc. */
	BLANK,
	
	/** There is no disc at all in the drive. */
	EMPTY,
	
	/** There is an incomplete disc in the drive. */
	APPENDABLE,
	
	/** There is a disc with data on it in the drive. */
	FULL,

	/* ts A61007 */
	/** The drive was not grabbed when the status was inquired. */
	UNGRABBED,

	/* ts A61020 */
	/** The media seems not to be suitable for burning. */
	UNSUITABLE
	
}
