/*
 * BindingsUtil.h
 *
 * Copyright (c) 2007  Vreixo Formoso
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See COPYING file for details.
 */

#include <jni.h>
#include "libburn.h"


#ifndef _Bindings_Util
#define _Bindings_Util

/**
 * Creates a new TocEntry java class from a burn_toc_entry C struct
 */
jobject java_libburn_toc_entry_c2java(JNIEnv *env, struct burn_toc_entry *entry);

/** throws a new BurnException */
void java_libburn_throw_burn_exception(JNIEnv *env, const char *msg);

/**
 * Get a reference for a class.
 * Reference is a global weak ref, so it can be cached.
 */
jclass java_libburn_find_class(JNIEnv *env, const char *name);

/** get a JNIEnv */
JNIEnv* java_libburn_get_env();

#endif
