/*
 * ReadOpts.c
 *
 * Copyright (c) 2007  Vreixo Formoso
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See COPYING file for details.
 */

#include "org_pykix_libburnia_libburn_ReadOpts.h"

#include "libburn.h"


/*
 * Class:     org_pykix_libburnia_libburn_ReadOpts
 * Method:    burn_read_opts_free
 * Signature: (J)V
 */
JNIEXPORT void JNICALL Java_org_pykix_libburnia_libburn_ReadOpts_burn_1read_1opts_1free
(
	JNIEnv *env, jclass cls, jlong opts
)
{
	burn_read_opts_free( (struct burn_read_opts *) opts);
}

/*
 * Class:     org_pykix_libburnia_libburn_ReadOpts
 * Method:    burn_read_opts_set_raw
 * Signature: (JZ)V
 */
JNIEXPORT void JNICALL 
Java_org_pykix_libburnia_libburn_ReadOpts_burn_1read_1opts_1set_1raw
(
	JNIEnv *env, jclass cls, jlong opts, jboolean yes
)
{
	burn_read_opts_set_raw( (struct burn_read_opts *) opts, yes);
}

/*
 * Class:     org_pykix_libburnia_libburn_ReadOpts
 * Method:    burn_read_opts_set_c2errors
 * Signature: (JZ)V
 */
JNIEXPORT void JNICALL Java_org_pykix_libburnia_libburn_ReadOpts_burn_1read_1opts_1set_1c2errors
(
	JNIEnv *env, jclass cls, jlong opts, jboolean yes
)
{
	burn_read_opts_set_c2errors( (struct burn_read_opts *) opts, yes);
}

/*
 * Class:     org_pykix_libburnia_libburn_ReadOpts
 * Method:    burn_read_opts_read_subcodes_audio
 * Signature: (JZ)V
 */
JNIEXPORT void JNICALL Java_org_pykix_libburnia_libburn_ReadOpts_burn_1read_1opts_1read_1subcodes_1audio
(
	JNIEnv *env, jclass cls, jlong opts, jboolean yes
)
{
	burn_read_opts_read_subcodes_audio( (struct burn_read_opts *) opts, yes);
}

/*
 * Class:     org_pykix_libburnia_libburn_ReadOpts
 * Method:    burn_read_opts_read_subcodes_data
 * Signature: (JZ)V
 */
JNIEXPORT void JNICALL Java_org_pykix_libburnia_libburn_ReadOpts_burn_1read_1opts_1read_1subcodes_1data
(
	JNIEnv *env, jclass cls, jlong opts, jboolean yes
)
{
	burn_read_opts_read_subcodes_data( (struct burn_read_opts *) opts, yes);
}

/*
 * Class:     org_pykix_libburnia_libburn_ReadOpts
 * Method:    burn_read_opts_set_hardware_error_recovery
 * Signature: (JZ)V
 */
JNIEXPORT void JNICALL Java_org_pykix_libburnia_libburn_ReadOpts_burn_1read_1opts_1set_1hardware_1error_1recovery
(
	JNIEnv *env, jclass cls, jlong opts, jboolean yes
)
{
	burn_read_opts_set_hardware_error_recovery( (struct burn_read_opts *) opts, yes);
}

/*
 * Class:     org_pykix_libburnia_libburn_ReadOpts
 * Method:    burn_read_opts_report_recovered_errors
 * Signature: (JZ)V
 */
JNIEXPORT void JNICALL Java_org_pykix_libburnia_libburn_ReadOpts_burn_1read_1opts_1report_1recovered_1errors
(
	JNIEnv *env, jclass cls, jlong opts, jboolean yes
)
{
	burn_read_opts_report_recovered_errors( (struct burn_read_opts *) opts, yes);
}

/*
 * Class:     org_pykix_libburnia_libburn_ReadOpts
 * Method:    burn_read_opts_transfer_damaged_blocks
 * Signature: (JZ)V
 */
JNIEXPORT void JNICALL Java_org_pykix_libburnia_libburn_ReadOpts_burn_1read_1opts_1transfer_1damaged_1blocks
(
	JNIEnv *env, jclass cls, jlong opts, jboolean yes
)
{
	burn_read_opts_transfer_damaged_blocks( (struct burn_read_opts *) opts, yes);
}

/*
 * Class:     org_pykix_libburnia_libburn_ReadOpts
 * Method:    burn_read_opts_set_hardware_error_retries
 * Signature: (JI)V
 */
JNIEXPORT void JNICALL Java_org_pykix_libburnia_libburn_ReadOpts_burn_1read_1opts_1set_1hardware_1error_1retries
(
	JNIEnv *env, jclass cls, jlong opts, jint r
)
{
	burn_read_opts_set_hardware_error_retries( (struct burn_read_opts *) opts, r);
}

